(* Simple error test *)
open Unix
(*ERR
Exit
*)

let server = ref (gethostname ())
and nsend = ref 10

let () = Arg.parse
  ["-n", Arg.Int (fun i -> nsend := i),
   "  n, number of tasks attemptying connection ["^string_of_int !nsend^"]";
  ]
  (fun s -> server := s)
  (Printf.sprintf "%s [-opt]* [server]" Sys.argv.(0))

let addr = (gethostbyname !server).h_addr_list.(0)

let ns = Join.Ns.of_sockaddr (ADDR_INET (addr, 12345))

let show =
  (Join.Ns.lookup ns "show" : (int * int * Join.Site.t Join.chan) Join.chan)

def fail() = prerr_endline "Exit" ; exit 0 ; 0

def hook(dist) & once() = Join.Site.at_fail dist fail ; more()
or  hook(_) & more() = more()

let _ = spawn once()

let id x = x 

let _ = spawn
  for i = 1 to !nsend do
    show(id i,!nsend, hook)
  done



let dead () =
  let lock = Mutex.create () in
  Mutex.lock lock ;
  Mutex.lock lock

let _ = dead()
