(* Connection test, multiple senders *)
   
(*OUT
10
*)

(*ERR
++++++++++
*)

let () = Join.Site.listen (Unix.ADDR_INET (Join.Site.get_local_addr (), 12345))

let ns = Join.Ns.here

def count(n,r) & sub(_) = count(n-1,r+1)
or  count(0,r) & wait() = reply r to wait

def start(n) & once() = count(n,0) & more()
or  start(_) & more() = more()

let _ = spawn once()

def show(x,n,k) =
  prerr_char '+' ; flush stderr ;
  k(Join.Site.here) & start(n) & sub(x)

let _ = Join.Ns.register ns "show" show

let r = wait()

let () = Printf.printf "%i\n" r ; prerr_newline ()



