
let server = ref (gethostname ())
let id = ref "0"
and oid = ref "1"

let () = Arg.parse
  [
   "-id", Arg.String (fun s -> id := s), " id, give  identity" ;
   "-oid", Arg.String (fun s -> oid := s), " id, give partner identity" ;
  ] 
  (fun s -> server := s)
  (Printf.sprintf "%s [-opt]* [server]" Sys.argv.(0))

let addr = (gethostbyname !server).h_addr_list.(0)

let ns = Ns.register_client addr 12345

let server = (Ns.lookup ns "server" : Join.site)

let _ = Join.at_fail server (def e() = exit 0 ; 0 in e)

let tick = (Ns.lookup ns "tick : unit channel)

let work(x) = Printf.printf "%i\n" x ; tick()

let _ = Ns.register ns (!id ^ "work") work

let owork = (Ns.lookup ns (!oid ^ "work") : unit channel)

let dead () =
  let lock = Mutex.create () in
  Mutex.lock lock ;
  Mutex.lock lock

let _ = dead()
