(* Connection test, reciprocal connection of two clients *)

let () = Join.Site.listen (Unix.ADDR_INET (Join.Site.get_local_addr (), 12345))

let ns = Join.Ns.here

def tick() & start() = more()
or  tick() & more() = over()
or  over() & wait() = reply to wait

let () = spawn start()

let () = Join.Ns.register ns "tick" tick

let () = Join.Ns.register ns "server" Join.Site.here

def sync0() & sync1() = reply to sync0 & reply to sync1

let _ = Join.Ns.register ns "sync0" sync0 ;  Join.Ns.register ns "sync1" sync1

let () = wait()




