(* Simple reply test forwarders *)
open Unix

(*OUT
FIB: 89
*)

let server =
  if Array.length Sys.argv > 1 then Sys.argv.(1)
  else gethostname ()

let addr = (gethostbyname server).h_addr_list.(0)

let ns = Join.Ns.of_sockaddr (ADDR_INET (addr, 12345))

let fib = (Join.Ns.lookup ns "fib" : (int -> int) )


let _ = Printf.printf "FIB: %i\n" (fib 10)

