open Unix
(* Remote communication on three sync channels, client side *)

(*OUT
2
0
1
*)

let server =
  if Array.length Sys.argv > 1 then Sys.argv.(1)
  else gethostname ()

let addr = (gethostbyname server).h_addr_list.(0)

let ns = Join.Ns.of_sockaddr (ADDR_INET (addr, 12345))

type ii = int -> int
let (w:unit -> unit), (f : ii), (g : ii) , (h : ii)  = Join.Ns.lookup ns "wfgh"



let _ = spawn let _ = g(g(g(1))) in 0
let _ = Printf.printf "%i\n" (h(h(h(2)))) ; flush Pervasives.stdout

let _ = spawn let _ = h(h(h(2))) in 0
let _ = Printf.printf "%i\n" (f(f(f(0)))) ; flush Pervasives.stdout


let _ = spawn let _ = f(f(f(0))) in 0
let _ = Printf.printf "%i\n" (g(g(g(1)))) ; flush Pervasives.stdout

let _ = try w() with e -> ()

