open Unix

let _ = Join.set_identity 12345

def show(x) & tick() =
  Printf.printf "%s\n" x ; flush Pervasives.stdout ; reply to show

let _ = spawn tick() 

let _ = Join.register_service "show" show

def wait() & lock() = reply to wait

let service = Join.remote_service (ADDR_INET (Ns.local_addr, 12345)) "show"

let _ = wait()
