(* Fork present in case of exception in async threads *)

(*OUT
0
0
*)

(* The error message can change, checker will count words *)
(*DIFF ERR ./diffwords *)
(*ERR
Thread 4 killed on uncaught exception Invalid_argument("index out of bounds")
Thread 5 killed on uncaught exception Invalid_argument("index out of bounds")
*)


def test(t) =
  tick() &
  for i=0 to Array.length t-1 do
    show(t.(2*i))
  done

and show(x) & tick() =
  Printf.printf "%i\n" x ; flush stdout ;
  tick()


let _ = spawn test([|0;0;0;0|])

let _ = at_exit Join.exit_hook

