(*
  Join encoding of data structures
*)

(*OUT
5
*)
def create(x,y) =
  def self () = reply x,y to self in
  reply self to create

def fst(p) = let x,_ = p() in reply x to fst
and snd(p) = let _,y = p() in reply y to snd

let p = create (1, "four")

let _ = print_int (fst(p) + String.length (snd(p))) ; print_newline ()

(*OUT
1coucou
*)

def echo(i) & echo_string(s) & wait() =
  Printf.printf "%i%s\n" i s ; flush stdout ;
  reply to wait

let make_it () =
  def port(p) & arg(x) = p x in
  port, arg

let p1, a1 = make_it ()
and p2, a2 = make_it ()


let _ = spawn begin
  p1(echo) & p2(echo_string) & a1(1) & a2("coucou")
end

let _ = wait()
