(* Exceptions in for loops *)
(*OUT
**********
*)
(*DIFF ERR ./diffwords *)
(*ERR
Thread 1 killed on uncaught exception Pervasives.Exit
Thread 1 killed on uncaught exception Pervasives.Exit
Thread 1 killed on uncaught exception Pervasives.Exit
Thread 1 killed on uncaught exception Pervasives.Exit
Thread 1 killed on uncaught exception Pervasives.Exit
Thread 1 killed on uncaught exception Pervasives.Exit
Thread 1 killed on uncaught exception Pervasives.Exit
Thread 1 killed on uncaught exception Pervasives.Exit
Thread 1 killed on uncaught exception Pervasives.Exit
Thread 1 killed on uncaught exception Pervasives.Exit
*)
let n = if Array.length Sys.argv > 1 then int_of_string Sys.argv.(1) else 10

let waiter n = 
  def count(0) & wait() = reply to wait
  or  count(n) & tick() = count(n-1) in
  spawn count(n) ;
  tick, wait

let id z = z

def loop(f,n) & started() = 
  for i = 1 to n do f()  done &
  reply to started

let () =
  let tick, wait = waiter n in
  def echo_star() = print_char '*' ; flush stdout ; tick() in
  spawn loop(echo_star, n) ;
  started() ;
  wait() ;
  print_newline () ;
  let tick,wait =  waiter n in
  def raise_exit() = raise Exit ; 0 in
  spawn loop(def k() = raise_exit() & tick() in k, n) ;
  started() ;
  wait() ;
  ()

 (* force error printing of spawned raise_exit *)
let _ = at_exit Join.exit_hook
