(* Simple exception test *)

(*OUT
++
--
**
===
*)

def tick() & over() = print_newline () ; reply to over

def a() & b() = ignore (raise Exit) ; reply to a & reply to b

let _ =
  spawn
    ((try a() with Exit -> print_char '+') ; tick())

let _ = try b() with Exit -> print_char '+' ; over()

def a() & b() = (ignore (raise Exit) ; reply to a) &  reply to b

let _ =
  spawn
    ((try a() with Exit -> print_char '-') ; tick())

let _ = b() ; print_char '-' ; over()

def a() & b() = (ignore (raise Exit) ; reply to b) &  reply to a

let _ =
  spawn
    ((try b() with Exit -> print_char '*') ; tick())

let _ = a() ; print_char '*' ; over()


def tic() & toc() & over() = print_newline () ; reply to over

let f () = ignore (raise Not_found) ; ()

def a() & b() & c() =
  reply to a & ( f () ; reply to b & reply to c )

let _ =
  spawn begin
    ((try b() with Not_found -> print_char '=') ; tic())
    &
    ((try c() with Not_found -> print_char '=') ; toc())
  end

let _ = a() ;  print_char '=' ; over()
