(*
  Sync channels + patterns
*)
(*OUT
2
3
4
*)

def a([]) & b(xs) = reply xs to b & reply [] to a
or  a(xs) & b([]) = reply [] to b & reply xs to a
or  a(_::xs) & b(_::ys) =
   reply a(xs) to a & reply b(ys) to b

def wait(k) = count(k) & reply over() to wait
or  count(n) & printed() = count(n-1)
or  count(0) & over() = reply to over


def show([]) = flush stdout ; printed()
or  show(x::xs) = Printf.printf "%i\n" x ; show(xs)

let _ = spawn let xs = b([1;2;3]) in show(xs)
let _  = let xs = a([1]) in spawn show(xs)

let () = wait(2)

let _ = spawn let xs = a([1;3;4]) in show(xs)
let _  = let xs = b([1;2]) in spawn show(xs)

let () = wait(2) 
