(* Simple error test *)
open Unix
(*ERR
Exit
*)

let server =
  if Array.length Sys.argv > 1 then Sys.argv.(1)
  else gethostname ()

let addr = (gethostbyname server).h_addr_list.(0)

let ns = Join.Ns.of_sockaddr (ADDR_INET (addr, 12345))

let show = (Join.Ns.lookup ns "show" :
              (int * (Join.Site.t * unit Join.chan Join.chan) Join.chan)
              Join.chan)

def over() = prerr_endline "Exit" ; exit 0 ; 0
def alive() = prerr_endline "Alive" ; 0

def k(dist, f) = Join.Site.at_fail dist over ; f(alive)

let _ = spawn show(10, k)

let dead () =
  let lock = Mutex.create () in
  Mutex.lock lock ;
  Mutex.lock lock

let _ = dead()
