(* Simple reply test for forwarders *)
(*OUT
FIB: 89
*)
let () = Join.Site.listen (Unix.ADDR_INET (Join.Site.get_local_addr(), 12345))

let ns = Join.Ns.here

def fib(n) =
  if n <= 1 then
    reply 1 to fib
  else
    reply fib(n-1) + fib(n-2) to fib

let _ = Printf.printf "FIB: %i\n" (fib 10)


def gfib(n) =
  let r = fib(n) in
  kill() & reply r to gfib 

and kill() = exit 0 ; 0

  
let _ = Join.Ns.register ns "fib" gfib

(* Deadlock myself ! *)
let _ =
  let lock = Mutex.create () in
  Mutex.lock lock ;
  Mutex.lock lock ;
  ()
