(* Simple reply test *)
open Unix

(*OUT
F: 10
G: 10
*)

let server =
  if Array.length Sys.argv > 1 then Sys.argv.(1)
  else gethostname ()

let addr = (gethostbyname server).h_addr_list.(0)

let ns = Join.Ns.of_sockaddr (ADDR_INET (addr, 12345))


let w, f, g = (Join.Ns.lookup ns "wfg" : (unit -> unit) * (int -> int) * (int -> int))


let _ = Printf.printf "F: %i\n" (f 20)

let _ =  Printf.printf "G: %i\n" (g 20)

let _ = try w() with e -> ()
