(* Simple reply test *)
(*OUT
G: 20
F: 20
*)

let () = Join.Site.listen (Unix.ADDR_INET (Join.Site.get_local_addr (), 12345))

let ns = Join.Ns.here

def f(x) & g(y) = reply x to g & reply y to f

def wait() & wait'() = reply to wait & reply to wait'

let _ = Join.Ns.register ns "wfg" (wait', f, g)

let _ = Printf.printf "G: %i\n" (g 10) ; flush stdout

let _ =  Printf.printf "F: %i\n" (f 10) ; flush stdout

let _ = try wait () with e -> ()

