(* Test link with ocaml library num *)
(*OUT
32!= 263130836933693530167218012160000000
C 10 5 = 252
*)
let n =
  if Array.length Sys.argv > 1 then int_of_string Sys.argv.(1)
  else 32

let rec big_fact r i =
  if i <= 0 then r
  else big_fact (Num.mult_num r (Num.num_of_int i)) (i-1)

let () =
  Printf.printf "%d!= %s\n"
    n
    (Num.string_of_num (big_fact (Num.num_of_int 1) n))

open Num

def comb (n,p,k) =
  if p = 0 || p = n then k(num_of_int 1)
  else
    def arg1(x) & arg2(y)  = k(add_num x y) in
    comb (n-1,p,arg1) & comb (n-1,p-1,arg2)

def wait() & over() = reply to wait

let n = 10

let p = n/2

def k(r) =
  Printf.printf "C %d %d = %s\n" n p (Num.string_of_num r) ;
  over()

let () = spawn comb(n,p,k) ; wait ()



